'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = reduce;

var _client = require('@slack/client');

var _helpers = require('./helpers');

function reduce() {
  let state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  let action = arguments[1];
  let type = action.type;
  let message = action.message;


  switch (type) {
    case _helpers.RTM_START:
      return (0, _helpers.populateFromRtmStart)(state, action.data.bots);
    case _client.RTM_EVENTS.BOT_ADDED:
    case _client.RTM_EVENTS.BOT_CHANGED:
      return addOrUpdateBot(state, message);
    default:
      return state;
  }
}

function addOrUpdateBot(state, _ref) {
  let bot = _ref.bot;

  let existingBot = state[bot.id];

  return _extends({}, state, {
    [bot.id]: _extends({}, existingBot, bot)
  });
}