'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = reduce;

var _client = require('@slack/client');

var _helpers = require('./helpers');

var _utils = require('./utils');

var _messagesReducer = require('./messages-reducer');

var _messagesReducer2 = _interopRequireDefault(_messagesReducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function reduce() {
  let state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  let action = arguments[1];

  if ((0, _utils.isHandledByMessagesReducer)(action.type)) {
    return (0, _messagesReducer2.default)(state, action);
  }

  let type = action.type;
  let message = action.message;


  switch (type) {
    case _helpers.RTM_START:
      return (0, _helpers.populateFromRtmStart)(state, action.data.ims);
    case _client.RTM_EVENTS.IM_CREATED:
      return (0, _helpers.addOrUpdateChannel)(state, message);
    case _client.RTM_EVENTS.IM_OPEN:
      return setDmOpen(state, message, true);
    case _client.RTM_EVENTS.IM_CLOSE:
      return setDmOpen(state, message, false);
    case _client.RTM_EVENTS.USER_TYPING:
      return (0, _helpers.userIsTyping)(state, message, action.isTyping);
    case _client.RTM_EVENTS.IM_HISTORY_CHANGED:
    default:
      return state;
  }
}

function setDmOpen(state, _ref, is_open) {
  let channel = _ref.channel;

  let dm = state[channel];
  if (!dm) return state;

  return _extends({}, state, {
    [dm.id]: _extends({}, dm, {
      is_open
    })
  });
}