'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DEFAULT_MESSAGE_ACTION = undefined;
exports.actionTypeWithSubtype = actionTypeWithSubtype;
exports.subtypeFromActionType = subtypeFromActionType;
exports.actionNeedsSelfParameters = actionNeedsSelfParameters;
exports.isHandledByMessagesReducer = isHandledByMessagesReducer;

var _client = require('@slack/client');

const DEFAULT_MESSAGE_ACTION = exports.DEFAULT_MESSAGE_ACTION = 'rtm_client_add_message';

const SELF_PARAMETERS_REQUIRED = [_client.RTM_EVENTS.CHANNEL_LEFT, _client.RTM_EVENTS.GROUP_LEFT, _client.RTM_EVENTS.PREF_CHANGE, _client.RTM_EVENTS.MANUAL_PRESENCE_CHANGE, _client.RTM_EVENTS.TEAM_PREF_CHANGE, _client.RTM_EVENTS.TEAM_DOMAIN_CHANGE, _client.RTM_EVENTS.TEAM_RENAME];

const MESSAGE_REDUCER_TYPES = [_client.RTM_EVENTS.CHANNEL_MARKED, _client.RTM_EVENTS.REACTION_ADDED, _client.RTM_EVENTS.REACTION_REMOVED];

function actionTypeWithSubtype(subtype, delim) {
  return [_client.RTM_EVENTS.MESSAGE, subtype || DEFAULT_MESSAGE_ACTION].join(delim || '::');
}

function subtypeFromActionType(type, delim) {
  let parts = type.split(delim || '::');
  return parts.length === 2 ? parts[1] : null;
}

function actionNeedsSelfParameters(type) {
  return SELF_PARAMETERS_REQUIRED.indexOf(type) !== -1;
}

function isHandledByMessagesReducer(type) {
  return type.startsWith(_client.RTM_EVENTS.MESSAGE) || MESSAGE_REDUCER_TYPES.indexOf(type) !== -1;
}